/*
 * Copyright 2010-2011, Softnik Technologies
 * http://www.softnik.com/
 */


function clear_form_elements(ele) {
    $(ele).find(':input').each(function() {
        switch(this.type) {
            case 'password':
            case 'select-multiple':
            case 'select-one':
            case 'text':
            case 'textarea':
                $(this).val('');
                break;
            case 'checkbox':
            case 'radio':
                this.checked = false;
        }
    });
}

/////////////////////////////////////////////////////////////////////////////////////////

$(function() 
{
	$("#dialog-add-domains").dialog(
	{
		resizable: false,
		autoOpen: false,
		modal: true,
		buttons: {
			Clear: function() {
				clear_form_elements("#dialog-add-domains");
				$("#ui_domain_names").focus();
			},
			'OK': function() {
				$(this).dialog('close');
				var user_entry_data = $("#ui_domain_names").val();
				$.ajax({
					type: "POST",
					cache: false,
					dataType: 'json',
					url: grid_url_base + "?mode=ad",
					data: "data=" + user_entry_data + "&CategoryID=" + lastsel_categoryrow_id,
					success: function(html)
					{
						$("#"+domain_table_grid_id).trigger("reloadGrid"); 
					}
				});
			},
			Cancel: function() {
				$(this).dialog('close');
			}
		}
	});
	
	$("#dialog-add-subdomains").dialog(
	{
		resizable: false,
		autoOpen: false,
		modal: true,
		buttons: {
			Clear: function() {
				clear_form_elements("#dialog-add-subdomains");
				$("#ui_subdomains").focus();
			},
			'OK': function() {
				$(this).dialog('close');
				var user_entry_data = $("#ui_subdomains").val();
				var selids = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
				if(selids.length > 0 && selids != null)
				{
					$.ajax({
						type: "POST",
						cache: false,
						dataType: 'json',
						url: grid_url_base + "?mode=ah",
						data: "data=" + user_entry_data + "&id=" + selids,
						success: function(html)
						{
							$("#SubDomainTable").trigger("reloadGrid"); 
						}
					});
				}
			},
			Cancel: function() {
				$(this).dialog('close');
			}
		}
	});
	
	
	$("#dialog-lookup-what").dialog(
	{
		resizable: false,
		autoOpen: false,
		modal: true,
		buttons: {
			'OK': function() {
				// LOOKUP_DOMAIN_WHOIS | LOOKUP_DOMAIN_IP | LOOKUP_HTTP_HOMEPAGE | LOOKUP_ALEXA_DATA | LOOKUP_GOOGLE_PR | LOOKUP_MX_RECORDS | LOOKUP_PING_RESPONSE | LOOKUP_IP_WHOIS;
				var luw = 0;
				luw |= $('#luwhois').is(':checked') ? LOOKUP_DOMAIN_WHOIS : 0;
				luw |= $("#ludns").is(':checked') ? LOOKUP_DOMAIN_IP : 0;
				luw |= $("#luhttp").is(':checked') ? LOOKUP_HTTP_HOMEPAGE : 0;
				luw |= $("#lualexa").is(':checked') ? LOOKUP_ALEXA_DATA : 0;
				luw |= $("#lugpr").is(':checked') ? LOOKUP_GOOGLE_PR : 0;
				luw |= $("#lumx").is(':checked') ? LOOKUP_MX_RECORDS : 0;
				luw |= $("#luping").is(':checked') ? LOOKUP_PING_RESPONSE : 0;
				luw |= $("#luipwhois").is(':checked') ? LOOKUP_IP_WHOIS : 0;
				if(luw != 0)
				{
					DoLookups(luw);
					$(this).dialog('close');
				}
			},
			Cancel: function() {
				$(this).dialog('close');
			}
		}
	});
	
	$("#dialog-bulk-action").dialog(
	{
		resizable: false,
		autoOpen: false,
		width: 400,
		modal: true,
		buttons: 
		{
			Clear: function() {
				clear_form_elements("#bulk-action-form");
				$("#bt-notes-a").focus();
			},
			'OK': function() {
				var rowKey = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
				var lurl = "lib/php/bulktool.php?" + "id=" + rowKey;
				lurl += "&notes_a=" + $("#bt-notes-a").val();
				lurl += "&notes_b=" + $("#bt-notes-b").val();
				lurl += "&notes_c=" + $("#bt-notes-c").val();
				lurl += "&notes_d=" + $("#bt-notes-d").val();
				lurl += "&cat_add=" + $("#bt-cat-add").val();
				lurl += "&cat_delete=" + $("#bt-cat-delete").val();
				//alert(lurl);
				$.ajax({
					type: "GET",
					cache: false,
					url: lurl,
					success: function(html)
					{
						jQuery("#"+domain_table_grid_id).trigger("reloadGrid"); 
					}
				});
				$(this).dialog('close');
			},
			Cancel: function() {
				$(this).dialog('close');
			}
		}
	});
});

