/*
 * Copyright 2010-2011, Softnik Technologies
 * http://www.softnik.com/
 */


///////////////////////////////////////////////////////////////////////////////
var domain_table_grid_id    = "DomainTableGrid";
var domain_table_pager_id   = "DomainTablePager";
var lastsel_domainrow_id    = 0;
var lastsel_categoryrow_id  = 0;
var last_sel_autoquery_id   = 0;

///////////////////////////////////////////////////////////////////////////////
var NO_DOMAIN_SELECTION     = 0; 
var SINGLE_DOMAIN_SELECTION = 1; 
var MULTI_DOMAIN_SELECTION  = 2; 

var LOOKUP_DOMAIN_WHOIS		= 1;
var LOOKUP_DOMAIN_IP		= 2;
var LOOKUP_HTTP_HOMEPAGE	= 4;
var LOOKUP_ALEXA_DATA		= 16;
var LOOKUP_GOOGLE_PR		= 32;
var LOOKUP_MX_RECORDS       = 128;
var LOOKUP_PING_RESPONSE    = 256;
var LOOKUP_SSL_CERTS		= 2048;
var LOOKUP_IP_WHOIS			= 4096;

///////////////////////////////////////////////////////////////////////////////

var date_columns_array      = [
			{label:'Domain',name:'domain',index:'domain', width:170, editable:true,editoptions:{readonly:true}},
			{label:'Registry Expiry',name:'registry_expiry',index:'registry_expiry', width:100, sorttype:"date", datefmt: "d-m-YYYY", editable:true,formatter:'date', formatoptions:{srcformat:"Y-m-d",newformat:"d-M-Y"}},
			{label:'Registrar Expiry',name:'registrar_expiry',index:'registrar_expiry', width:100, sorttype:"date", datefmt: "d-m-YYYY", editable:true,formatter:'date', formatoptions:{srcformat:"Y-m-d",newformat:"d-M-Y"}},
			{label:'Created On',name:'created_on',index:'created_on', width:100, sorttype:"date", editable:true,formatter:'date', formatoptions:{srcformat:"Y-m-d",newformat:"d-M-Y"}}, 
			{label:'Last Update',name:'last_update',index:'last_update', width:100, sorttype:"date", editable:true,formatter:'date', formatoptions:{srcformat:"Y-m-d",newformat:"d-M-Y"}},
			{label:'Lookedup',name:'lookedup',index:'lookedup', width:150, sorttype:"date", editable:false, formatter:'date', formatoptions:{srcformat:"Y-m-d H:i:s",newformat:"d-M-Y H:i:s"}},
];

var http_columns_array      = [
			{label:'Domain',name:'domain',index:'domain', width:170, editable:true,editoptions:{readonly:true}},
			{label:'IP',name:'ip',index:'ip', width:100, editable:true},
			//{label:'Size',name:'home_page_size',index:'home_page_size', width:90, editable:true},
			{label:'Page Title',name:'home_page_title',index:'home_page_title', width:90, editable:true},
			{label:'Page Status',name:'home_page_status',index:'home_page_status', width:120, editable:true},
			{label:'Redirect URL',name:'redirect_url',index:'redirect_url', width:120, editable:true},
			{label:'Home Page Checked At',name:'home_page_checked_at',index:'home_page_checked_at', width:120, sorttype:"date", editable:false, formatter:'date', formatoptions:{srcformat:"Y-m-d H:i:s",newformat:"d-M-Y H:i:s"}},
];

var registrar_columns_array      = [
			{label:'Domain',name:'domain',index:'domain', width:170, editable:true,editoptions:{readonly:true}},
			{label:'Registrar',name:'registrar',index:'registrar', width:120, editable:true},
			{label:'Status',name:'status',index:'status', width:120, editable:true},
			{label:'Last Update',name:'last_update',index:'last_update', width:100, sorttype:"date", editable:true,formatter:'date', formatoptions:{srcformat:"Y-m-d",newformat:"d-M-Y"}},
			{label:'Lookedup',name:'lookedup',index:'lookedup', width:150, sorttype:"date", editable:false, formatter:'date', formatoptions:{srcformat:"Y-m-d H:i:s",newformat:"d-M-Y H:i:s"}},
];

var network_columns_array      = [
			{label:'Domain',name:'domain',index:'domain', width:170, editable:true,editoptions:{readonly:true}},
			{label:'NS1',name:'ns1',index:'ns1', width:120, editable:true},
			{label:'NS2',name:'ns2',index:'ns2', width:120, editable:true},
			{label:'NS3',name:'ns3',index:'ns3', width:120, editable:true},
			{label:'Ping',name:'ping_time',index:'ping_time', width:120, editable:false},
			{label:'MX 1',name:'mx1',index:'mx1', width:120, editable:true},
			{label:'MX 2',name:'mx2',index:'mx2', width:120, editable:true},
			{label:'IP',name:'ip',index:'ip', width:120, editable:true},
];

var sitepop_columns_array      = [
			{label:'Domain',name:'domain',index:'domain', width:170, editable:true,editoptions:{readonly:true}},
			{label:'Goog PR',name:'google_pr',index:'google_pr', width:80, editable:true},
			{label:'Alexa Links',name:'alexa_links',index:'alexa_links', width:80, editable:true},
			{label:'Alexa Rank',name:'alexa_rank',index:'alexa_rank', width:80, editable:true},
			{label:'Ping',name:'ping_time',index:'ping_time', width:120, editable:true},
			{label:'IP',name:'ip',index:'ip', width:120, editable:true},
];

var notes_columns_array      = [
			{label:'Domain',name:'domain',index:'domain', width:170, editable:true,editoptions:{readonly:true}},
			{label:'Notes A',name:'notes_a',index:'notes_a', width:130, editable:true},
			{label:'Notes B',name:'notes_b',index:'notes_b', width:130, editable:true},
			{label:'Notes C',name:'notes_c',index:'notes_c', width:130, editable:true},
			{label:'Notes D',name:'notes_d',index:'notes_d', width:130, editable:true},
			{label:'IP',name:'ip',index:'ip', width:120, editable:true}
];

var ipdata_columns_array      = [
			{label:'Domain',name:'domain',index:'domain', width:170, editable:true,editoptions:{readonly:true}},
			{label:'IP',name:'ip',index:'ip', width:100, editable:true},
			{label:'IP Org',name:'ip_org_name',index:'ip_org_name', width:120, editable:true},
			{label:'IP Net',name:'ip_net_name',index:'ip_net_name', width:120, editable:true},
			{label:'IP ASN',name:'ip_asnumber',index:'ip_asnumber', width:70, editable:true},
			{label:'IP AS Name',name:'ip_asname',index:'ip_asname', width:200, editable:true}
];

///////////////////////////////////////////////////////////////////////////////

var current_columns_array  = date_columns_array;

///////////////////////////////////////////////////////////////////////////////

var domain_table_multi_select = true;
var show_domain_details    = true;

//  Forces reload of the domain table. Mostly used when a domain category changes.
var reload_domain_grid_data_url = true;
var reload_subdomain_grid_data_url = true;

// Restore category selection from last session.
var ccategory = parseInt($.cookie("current_category"));
if ( !isNaN(ccategory) )
	lastsel_categoryrow_id = ccategory;
	
///////////////////////////////////////////////////////////////////////////////

$(function()
{
	LoadDomainGrid();
	LoadCategoryGrid();
	LoadQueryGrid();
	LoadSubDomainGrid();
	LoadVersionInfo();
	
	$("#DetailsPane").bind('resize', function() { fixDomainDataGridSizes();	}).trigger('resize');
	$("#DomainTablePane").bind('resize', function() { fixDomainDataGridSizes();	}).trigger('resize');
	$("#CategoryPane").bind('resize', function() { FixCategoryGridSizes(); }).trigger('resize'); 	
	
	$('#DomainDetailTabView').tabs();
	$('#CategoryTabView').tabs();
	
	$("#SubDomainTable").trigger("reloadGrid"); 
});

///////////////////////////////////////////////////////////////////////////////

function FixCategoryGridSizes()
{
	jQuery("#DomainCategoryTable").setGridWidth($("#CategoryPane").width()-24-4, true); 
	jQuery("#DomainCategoryTable").setGridHeight($("#CategoryPane").height()-94-36); 
	
	jQuery("#DomainQueryTable").setGridWidth($("#CategoryPane").width()-24-4, true); 
	jQuery("#DomainQueryTable").setGridHeight($("#CategoryPane").height()-94-36); 
}

///////////////////////////////////////////////////////////////////////////////

function fixDomainDataGridSizes()
{
	var autoShrink = true;
	if($("#DomainTablePane").width() < 500)
		autoShrink = false;
	jQuery("#"+domain_table_grid_id).setGridWidth($("#DomainTablePane").width()-24, autoShrink); 
	jQuery("#"+domain_table_grid_id).setGridHeight($("#DomainTablePane").height()-120); 
	
	jQuery("#DomainDetailTabView").width($("#DetailsPane").width()-27, true); 
	jQuery("#DomainDetailTabView").height($("#DetailsPane").height()-26);
	
	jQuery("#SubDomainTable").setGridWidth($("#DomainDetailTabView").width()-36, autoShrink); 
	jQuery("#SubDomainTable").setGridHeight($("#DomainDetailTabView").height()-120-32); 
}

///////////////////////////////////////////////////////////////////////////////

function showWhoisData(status, ids)
{
	if(status == MULTI_DOMAIN_SELECTION)
	{
		jQuery("#registrywhois").html("Multiple domains selected");
		jQuery("#registrarwhois").html("Multiple domains selected");
		jQuery("#ipdata").html("Multiple domains selected");
	}
	else if(status == NO_DOMAIN_SELECTION)
	{
		jQuery("#registrywhois").html("No domain is selected");
		jQuery("#registrarwhois").html("No domain is selected");
		jQuery("#ipdata").html("No domain is selected");
	}
	else
	{
		var domainname = jQuery("#"+domain_table_grid_id).getCell(ids, "domain"); 
		//jQuery("#editview").html("<p>" + ids + " " + domainname + "</p>");
		
		$.ajax({
			type: "GET",
			cache: false,
			dataType: 'json',
			url: grid_url_base + "?mode=wd&id=" + ids,
			success: function(html)
			{
				var heading = "<h3>" + domainname + "</h3>";
				$("#registrywhois").html(heading + html.rows[0].registry_whois);
				$("#registrarwhois").html(heading + html.rows[0].registrar_whois);
				$("#ipdata").html(heading + html.rows[0].ip_whois);
			}
		});
	}
	$("#SubDomainTable").trigger("reloadGrid"); 
}

///////////////////////////////////////////////////////////////////////////////

function ToggleDomainGrid()
{
	if(current_columns_array === date_columns_array)
		ShowHttpGrid();
	else
		ShowDateGrid();
}

///////////////////////////////////////////////////////////////////////////////

function ShowDateGrid()
{
	if(current_columns_array !== date_columns_array)
	{
		current_columns_array = date_columns_array;
		$("#" + domain_table_grid_id).GridUnload(); 
		reload_domain_grid_data_url = true;
		LoadDomainGrid();
	}
}

///////////////////////////////////////////////////////////////////////////////

function ShowHttpGrid()
{
	if(current_columns_array !== http_columns_array)
	{
		current_columns_array = http_columns_array;
		$("#" + domain_table_grid_id).GridUnload(); 
		reload_domain_grid_data_url = true;
		LoadDomainGrid();
	}
}

///////////////////////////////////////////////////////////////////////////////

function ShowRegistrarGrid()
{
	if(current_columns_array !== registrar_columns_array)
	{
		current_columns_array = registrar_columns_array;
		$("#" + domain_table_grid_id).GridUnload(); 
		reload_domain_grid_data_url = true;
		LoadDomainGrid();
	}
}

///////////////////////////////////////////////////////////////////////////////

function ShowSitePopGrid() {ShowGrid(sitepop_columns_array);}
function ShowNetworkGrid() {ShowGrid(network_columns_array);}
function ShowNotesGrid()   {ShowGrid(notes_columns_array);}
function ShowIPDataGrid()  {ShowGrid(ipdata_columns_array);}

///////////////////////////////////////////////////////////////////////////////

function ShowGrid(grid_array)
{
	if(current_columns_array !== grid_array)
	{
		current_columns_array = grid_array;
		$("#" + domain_table_grid_id).GridUnload(); 
		reload_domain_grid_data_url = true;
		LoadDomainGrid();
	}
}

///////////////////////////////////////////////////////////////////////////////

function LoadDomainGrid()
{
	// The main domain table
	jQuery("#" + domain_table_grid_id).jqGrid({
		editurl: grid_url_base,
		altRows:true,
		altclass: "ui-priority-secondary",
		height: $("#DomainTablePane").height()-120,
		width: $("#DomainTablePane").width()-24,
		loadtext: "Working...",
		datatype: "json",
		colModel: current_columns_array,
		rowNum:100,
		rowList:[10,50,100,250,500,1000],
		rowTotal: 100,
		pager: "#"+domain_table_pager_id,
		sortname: "sid",
		rownumbers: true,
		viewrecords: true,
		recordtext: "Domains {0} - {1} of {2}",
		sortorder: "desc",
		mtype: 'GET',
		multiselect: domain_table_multi_select,
		multiboxonly:domain_table_multi_select,
		gridView: true,
		scrollOffset:18,
		shrinkToFit: false,
		caption:"Domain Name Portfolio",
		
		jsonReader : {repeatitems: false},
		
		beforeRequest: function() 
		{
			if(reload_domain_grid_data_url == true)
			{
				var columns = jQuery("#"+domain_table_grid_id).getGridParam("colModel");
				var colnum = columns.length;
				var durl = grid_url_base + "?mode=dd&CategoryID=" + lastsel_categoryrow_id + "&columns=sid,";
				for(i = 0; i < colnum; i++)
				{
					if(columns[i].name != "rn" && columns[i].name != "cb")
					{
						durl += columns[i].name;
						durl += ",";
					}
				}
				if(last_sel_autoquery_id > 0)
					durl += "&aqid=" + last_sel_autoquery_id;
				jQuery("#"+domain_table_grid_id).setGridParam({url:durl});
				reload_domain_grid_data_url = false;
			}
		},
		
		onSelectAll: function(ids, status)
		{
			if(show_domain_details == true)
			{
				reload_subdomain_grid_data_url = true;
				if(status == false)
				{
					showWhoisData(NO_DOMAIN_SELECTION);
				}
				else
				{
					var allIDs  = jQuery("#"+domain_table_grid_id).getDataIDs(); 
					if(allIDs.length == 1)
					{
						showWhoisData(SINGLE_DOMAIN_SELECTION, allIDs[0]); 
					}
					else 
					{
						showWhoisData(MULTI_DOMAIN_SELECTION);
					}
				}
			}
		},
		
		onSelectRow: function(ids) 
		{
			if(show_domain_details == true)
			{
				reload_subdomain_grid_data_url = true;
				if(ids == null || ids == 0)
					showWhoisData(NO_DOMAIN_SELECTION);
				else  
				{
					var selids = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
					if(selids.length > 1)
						showWhoisData(MULTI_DOMAIN_SELECTION);
					else
						showWhoisData(SINGLE_DOMAIN_SELECTION, ids);
				}
			}
			lastsel_domainrow_id = ids;
			$.cookie('current_domain', String(ids)); 
		},
		
		gridComplete: function()
		{
			$("#registrywhois").html("");
			$("#registrarwhois").html("");
		
			var sel_rowid = 0;
			var allIDs = jQuery("#"+domain_table_grid_id).getDataIDs(); 
			if(allIDs.length > 0)
				sel_rowid = allIDs[0];
				
			var cdomain = parseInt($.cookie("current_domain"));
			if ( !isNaN(cdomain) )
				sel_rowid = cdomain;
			$("#"+domain_table_grid_id).setSelection(sel_rowid, true);
			$("#"+domain_table_grid_id).setGridParam({scrollrows:false}); 
		},
		
		loadComplete: function()
		{
		}
	});
	
	// We use our own "add records" because we want to allow only domain names to be added.
	
	jQuery("#"+domain_table_grid_id)
	.navGrid('#'+domain_table_pager_id,{add:false,edit:true,del:true},{},{},{},{multipleSearch:true})
	.navSeparatorAdd("#"+domain_table_pager_id,{})
	.navButtonAdd('#'+domain_table_pager_id,
	{
		caption:"", 
		buttonicon:"ui-icon-check", 
		onClickButton: function()
		{ 
			var rowKey = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
			if(rowKey.length > 0)
				$('#dialog-lookup-what').dialog('open');
			return false;
		}, 
		position:"last",
		title:'Lookup Domain'
	})
	.navButtonAdd('#'+domain_table_pager_id,
	{
		// Add domain names
		caption:"", 
		buttonicon:"ui-icon-plus", 
		onClickButton: function()
		{ 
			$('#dialog-add-domains').dialog('open');
			return false;
		}, 
		position:"first"
	}
	);
	
	jQuery("#"+domain_table_grid_id).jqGrid(
		'filterToolbar',{
			stringResult: true,searchOnEnter : false,
			beforeSearch: function() 
			{
				var url = jQuery("#"+domain_table_grid_id).getGridParam('url');
				var newurl = url;
				var pos = url.search("&aqid=");
				if(pos > 0)
					newurl = url.substring(0,pos);
				//alert(url + "\n" + newurl);
				jQuery("#"+domain_table_grid_id).setGridParam({url:newurl});
				return false;
			}
		}
	);
}

///////////////////////////////////////////////////////////////////////////////

function DoLookups(luw)
{
	//var luw = LOOKUP_DOMAIN_WHOIS | LOOKUP_DOMAIN_IP | LOOKUP_HTTP_HOMEPAGE	| LOOKUP_ALEXA_DATA | LOOKUP_GOOGLE_PR | LOOKUP_MX_RECORDS | LOOKUP_PING_RESPONSE | LOOKUP_IP_WHOIS;
	var rowKey = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
	var lurl = grid_url_base + "?mode=qd&what=" + luw + "&id=" + rowKey;
	if(rowKey.length <= 2)
		lurl += "&ri=0";
	$.ajax({
		type: "GET",
		cache: false,
		dataType: 'json',
		url: lurl,
		success: function(html)
		{
			
		}
	});
}

///////////////////////////////////////////////////////////////////////////////

function ConfigRegistrarWhois()
{
	window.location = 'wconfig.php';
}

///////////////////////////////////////////////////////////////////////////////

function DoBulkAction()
{
	var rowKey = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
	if(rowKey != null && rowKey.length > 0) 
	{
		if(rowKey.length == 1)
			$('#bt-domain-info').html("<p>" + rowKey.length + " domain selected.</p>");
		else
			$('#bt-domain-info').html("<p>" + rowKey.length + " domains selected.</p>");
		$('#dialog-bulk-action').dialog('open');
	}
}

///////////////////////////////////////////////////////////////////////////////

function AddDomains()
{
	$('#dialog-add-domains').dialog('open');
	return false;
}

///////////////////////////////////////////////////////////////////////////////

function DeleteDomains()
{
	var rowKey = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
	if(rowKey != null && rowKey.length > 0) 
        jQuery("#"+domain_table_grid_id).delGridRow(rowKey,{reloadAfterSubmit:true});  
}
	
///////////////////////////////////////////////////////////////////////////////

function LoadCategoryGrid()
{
	jQuery("#DomainCategoryTable").jqGrid({
		loadtext: "Working...",
		height: 400,
		width: 50,
		url: grid_url_base + '?mode=cd',
		editurl: grid_url_base + '?mode=cd',
		datatype: "json",
		colNames:['Category Names'],
		colModel:[
			{name:'CategoryName', width:50,sortable:true,editable:true}
		],
		rowNum:100,
		rowList:[100,200,500],
		rownumbers: true,
		viewrecords: true,
		recordtext: "{0} - {1} of {2}",
		caption:"Domain Categories",
		multiselect: false,
		pager: "#pagerCatView",
		scrollOffset:18,
		sortname: 'CategoryID',
		scroll:1,
		
		loadComplete: function()
		{
			jQuery("#CategoryPane").trigger('resize');
		},
		
		onSelectRow: function(ids) 
		{
			if(ids == null) 
				ids = 0;
			lastsel_categoryrow_id = ids;
			reload_domain_grid_data_url = true;
			last_sel_autoquery_id = 0;
			$("#"+domain_table_grid_id).trigger("reloadGrid");  
			$.cookie('current_category', String(ids));
		},
		
		gridComplete: function()
		{
			var sel_rowid = 0;
			var allIDs = jQuery("#DomainCategoryTable").getDataIDs(); 
			if(allIDs.length > 0)
				sel_rowid = allIDs[0];
			if(lastsel_categoryrow_id != 0)
				sel_rowid = lastsel_categoryrow_id;
			// if the category id cookie is wrong, force a refresh of the domain table.
			if(allIDs.length == 0 && lastsel_categoryrow_id != 0)
			{
				lastsel_categoryrow_id = 0;
				last_sel_autoquery_id = 0;
				reload_domain_grid_data_url = true;
				$("#"+domain_table_grid_id).trigger("reloadGrid");
				$.cookie('current_category', String(0));
			}
			$("#DomainCategoryTable").setSelection(sel_rowid, false);
			$("#DomainCategoryTable").setGridParam({scrollrows:false}); 
		}
	}).navGrid('#pagerCatView',{add:true,edit:true,del:true,search:false});
}
	
///////////////////////////////////////////////////////////////////////////////

function LoadQueryGrid()
{
	jQuery("#DomainQueryTable").jqGrid({
		loadtext: "Working...",
		height: 400,
		width: 50,
		url: grid_url_base + '?mode=aqd',
		editurl: grid_url_base + '?mode=aqd',
		datatype: "json",
		colNames:['Auto Queries'],
		colModel:[
			{name:'Name', width:50,sortable:true,editable:true},
		],
		rowNum:100,
		rowList:[100,200,500],
		rownumbers: true,
		viewrecords: true,
		recordtext: "{0} - {1} of {2}",
		caption:"Domain Queries",
		multiselect: false,
		pager: "#pagerQueryView",
		scrollOffset:18,
		sortname: 'Name',
		scroll:1,
		shrinkToFit: false,
		
		loadComplete: function()
		{
			jQuery("#CategoryPane").trigger('resize');
		},
		
		onSelectRow: function(ids) 
		{
			if(ids == null) 
				ids = 0;
			last_sel_autoquery_id = ids;
			reload_domain_grid_data_url = true;
			$("#"+domain_table_grid_id).trigger("reloadGrid");
			$("#DomainQueryTable").resetSelection();
			$("#DomainCategoryTable").resetSelection();
		},
		
		gridComplete: function()
		{
			$("#DomainQueryTable").setGridParam({scrollrows:false}); 
		}
	}).navGrid('#pagerQueryView',{add:false,edit:false,del:false,search:false,alertcap:"Alert"});
}
	
///////////////////////////////////////////////////////////////////////////////

function LoadSubDomainGrid()
{
	jQuery("#SubDomainTable").jqGrid({
		loadtext: "Working...",
		altRows:true,
		altclass: "ui-priority-secondary",
		height: 400,
		width: 50,
		gridView:true,
		url: grid_url_base + '?mode=sdd',
		editurl: grid_url_base + '?mode=sdd',
		datatype: "json",
		colModel:[
			{label:'Sub-domain', name:'subdomain', width:50,sortable:true,editable:true,editoptions:{readonly:true}},
			{label:'SSL Valid From', name:'ssl_valid_from', width:50,sortable:true,editable:false},
			{label:'SSL Valid To', name:'ssl_valid_to',width:50,sortable:true,editable:false},
			{label:'SSL Issued To', name:'ssl_issued_to',width:50,sortable:true,editable:false},
			{label:'SSL Issued By', name:'ssl_issued_by',width:50,sortable:true,editable:false}, 
			{label:'IP', name:'ip',width:50,sortable:true,editable:false},
			{label:'Notes', name:'notes_a',width:50,sortable:true,editable:true}
		],
		rowNum:100,
		rowList:[100,200,500],
		rownumbers: true,
		viewrecords: true,
		recordtext: "{0} - {1} of {2}",
		caption:"Sub-domains",
		multiselect: domain_table_multi_select,
		multiboxonly:domain_table_multi_select,
		pager: "#pagerSubDomainView",
		scrollOffset:18,
		sortname: 'subdomain',
		mtype: 'GET',
		scroll:1,
		shrinkToFit: false,
		jsonReader : {repeatitems: false},
		
		beforeRequest: function() 
		{
			var sid = 1000000000;
			var selids = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
			if(selids != null && selids.length == 1)
				sid = selids[0];
			if(reload_subdomain_grid_data_url == true)
			{
				var columns = jQuery("#SubDomainTable").getGridParam("colModel");
				var colnum = columns.length;
				var edurl = grid_url_base + "?mode=sdd&sid=" + sid;
				var durl = grid_url_base + "?mode=sdd&sid=" + sid + "&columns=hid,";
				for(i = 0; i < colnum; i++)
				{
					if(columns[i].name != "rn" && columns[i].name != "cb")
					{
						durl += columns[i].name;
						durl += ",";
					}
				}
				jQuery("#SubDomainTable").setGridParam({url:durl});
				jQuery("#SubDomainTable").setGridParam({editurl:edurl});
				reload_subdomain_grid_data_url = false;
			}
		},
		
		loadComplete: function()
		{
			
		},
		
		onSelectRow: function(ids) 
		{
			if(ids == null) 
				ids = 0;
		},
		
		gridComplete: function()
		{
		}
	});
	
	jQuery("#SubDomainTable")
	.navGrid('#pagerSubDomainView',{add:false,edit:true,del:true,search:false})
	.navSeparatorAdd("#pagerSubDomainView",{})
	.navButtonAdd('#pagerSubDomainView',
	{
		caption:"", 
		buttonicon:"ui-icon-check", 
		onClickButton: function()
		{ 
			var selids = jQuery("#"+domain_table_grid_id).getGridParam("selarrrow"); 
			var sid = -1;
			if(selids.length == 1)
			{
				var luw = LOOKUP_SSL_CERTS;
				sid = selids[0];
				var lurl = grid_url_base + "?mode=qd&what=" + luw + "&id=" + sid;
				if(sid.length <= 10)
					lurl += "&ri=0";
				$.ajax({
					type: "GET",
					cache: false,
					dataType: 'json',
					url: lurl,
					success: function(html)
					{
						
					}
				});
			}
		}, 
		position:"last",
		title:'Lookup Sub-domain'
	})
	.navButtonAdd('#pagerSubDomainView',
	{
		// Add domain names
		caption:"", 
		buttonicon:"ui-icon-plus", 
		onClickButton: function()
		{ 
			$('#dialog-add-subdomains').dialog('open');
			return false;
		}, 
		position:"first"
	}
	);
}

function LoadVersionInfo()
{
	var turl = grid_url_base + "?mode=ver";
	request = $.ajax({type: "POST",	url: turl});
	request.done(function(msg) 
	{  
		if(msg != "")
			$("#version_build_date").html("<p>" + msg + "</p>");
	});
}
