<?php

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_and_parse_homepage($domain, $subdomain="www", $spit_out=false)
{
	$host = idn_convert_to_host_name($domain, $subdomain);
	
	$url  = $host;
	
	$header = "";
	$body = "";
	get_http_header_body($url, $header, $body);
	$headers = explode("\n", $header);
	if(is_array($headers))
	{
		$data_array['home_page_status'] = $headers[0];
		$data_array['redirect_url'] = get_redirect_url_from_header($headers);
		$data_array['home_page_header'] = $header;
		$data_array['home_page_title'] = preg_match('/<title>(.*)<\/title>/smU', $body, $matches) ? $matches[1] : '';
		$data_array['home_page_size'] = mb_strlen($body);
	}
	$data_array['home_page_checked_at'] = date("Y-m-d H:i:s");
	
	if(is_array($data_array))
	{
		update_domain_table($data_array, $domain);
		if($spit_out)
			debug_out_domain_data($data_array);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_http_header_body($host, &$header, &$body)
{
	$content = "";
	$fp = fsockopen($host, 80, $errno, $errstr, 20);
	if ($fp) 
	{
		$out = "GET / HTTP/1.1\r\n";
		$out .= "Host: " . $host . "\r\n";
		$out .= "Connection: Close\r\n\r\n";
		fwrite($fp, $out);
		while (!feof($fp)) 
		{
			$content .= fgets($fp, 128);
		}
		fclose($fp);
	}
		
	$hunks = explode("\r\n\r\n",trim($content));
	if (is_array($hunks) && count($hunks) >= 1) 
	{
		$header  = $hunks[0];
		$hunks[0] = "";
		$body    = implode("\r\n", $hunks);
		return true;
	}
	return false;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_redirect_url_from_header($headers) 
{ 
	$url = "";
    $array = $headers; 
    $count = count($array); 
    for ($i=0; $i < $count; $i++) 
    { 
        if (strpos($array[$i], "ocation:")) 
        { 
                $url = substr($array[$i], 10); 
        } 
    } 
    return $url; 
} 

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_ping_response($domain, $subdomain="www")
{
	$host = idn_convert_to_host_name($domain, $subdomain);
	$url  = $host;
	
    $starttime = microtime(true);
    $file      = fsockopen ($url, 80, $errno, $errstr, 10);
    $stoptime  = microtime(true);
    $status    = 0;
    if (!$file) $status = -1;  // Site is down
    else 
	{
        fclose($file);
        $status = ($stoptime - $starttime) * 1000;
        $status = floor($status);
    }
	
	$data_array['ping_time'] = $status;
	$data_array['ping_checked_at'] = date("Y-m-d H:i:s");
	if(is_array($data_array))
		update_domain_table($data_array, $domain);
		
    return $status;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

?>
